import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _regeneratorRuntime from "@babel/runtime/regenerator";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import EventBus from './event-bus';

var CanvasComment = /*#__PURE__*/function (_EventBus) {
  _inherits(CanvasComment, _EventBus);

  var _super = _createSuper(CanvasComment);

  function CanvasComment(options) {
    var _this;

    _classCallCheck(this, CanvasComment);

    _this = _super.call(this);
    _this.canvas = void 0;
    _this.ctx = void 0;
    _this.image = new Image();
    _this.imageLoaded = void 0;
    _this.imageWidth = void 0;
    _this.imageHeight = void 0;
    _this.imageCrossOrigin = void 0;
    _this.scaleStep = void 0;
    _this.movePoint = void 0;
    _this.originPoint = [0, 0];
    _this.lastOriginPoint = [0, 0];
    _this.spaceKeyDown = false;
    _this.dataset = [];
    _this.readonly = false;
    _this.rectMinWidth = 10;
    _this.rectMinHeight = 10;
    _this.labelMaxLen = 40;
    _this.labelMinWidth = 120;
    _this.labelLineHeight = 20;
    _this.labelFont = '14px Arial';
    _this.labelFillStyle = 'red';
    _this.labelBackgroundColor = 'white';
    _this.rectStrokeStyle = 'red';
    _this.createType = void 0;
    _this.createLabelFillStyle = void 0;
    _this.createRectStrokeStyle = void 0;
    _this.currentShape = void 0;
    _this.minDrawSize = 5;
    var el = options.container,
        imgSrc = options.image;
    var container = typeof el === 'string' ? document.querySelector(el) : el;

    if (Object.prototype.toString.call(container).includes('HTMLCanvasElement')) {
      _this.canvas = container;
      _this.ctx = _this.canvas.getContext('2d');

      if (imgSrc) {
        _this.setImage(imgSrc);
      }

      _this.init();
    } else {
      console.warn('HTMLCanvasElement is required!');
    }

    return _this;
  }

  _createClass(CanvasComment, [{
    key: "ratio",
    get: function get() {
      var dpr = window.devicePixelRatio || 1;
      var bsr = this.ctx['webkitBackingStorePixelRatio'] || this.ctx['mozBackingStorePixelRatio'] || this.ctx['msBackingStorePixelRatio'] || this.ctx['oBackingStorePixelRatio'] || this.ctx['backingStorePixelRatio'] || 1;
      return dpr / bsr;
    }
  }, {
    key: "scale",
    get: function get() {
      if (this.image.width && this.imageWidth) {
        return this.imageWidth / this.image.width;
      }

      return 1;
    }
  }, {
    key: "activeShape",
    get: function get() {
      return this.dataset.find(function (x) {
        return x.active;
      });
    } // 初始化

  }, {
    key: "init",
    value: function () {
      var _init = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var _this2 = this;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.loadImage();

              case 2:
                document.body.addEventListener('keydown', function (e) {
                  if (e.code === 'Space') {
                    _this2.spaceKeyDown = true;
                  }
                });
                document.body.addEventListener('keyup', function (e) {
                  var _this2$activeShape;

                  _this2.spaceKeyDown = false;

                  if (e.key === 'Backspace' && !((_this2$activeShape = _this2.activeShape) !== null && _this2$activeShape !== void 0 && _this2$activeShape.creating)) {
                    _this2.deleteActiveShape();
                  }
                }); // this.canvas.addEventListener('mousewheel', (e: WheelEvent) => {
                //   e.preventDefault();
                //   this.setScale(e.deltaY < 0);
                //   this.update();
                // });

                this.canvas.addEventListener('mousedown', function (e) {
                  if (_this2.readonly) return;
                  var offsetX = Math.round(e.offsetX / _this2.scale);
                  var offsetY = Math.round(e.offsetY / _this2.scale);
                  _this2.movePoint = [offsetX, offsetY];
                  _this2.lastOriginPoint = [e.offsetX - _this2.originPoint[0], e.offsetY - _this2.originPoint[1]];

                  if (e.buttons === 1) {
                    if (_this2.createType === 'rect' && _this2.isInBackground(e)) {
                      // -- 画矩形 --
                      var nx = Math.round(offsetX - _this2.originPoint[0] / _this2.scale);
                      var ny = Math.round(offsetY - _this2.originPoint[1] / _this2.scale);
                      var curPoint = [nx, ny]; // fix: 录入完成，鼠标移出，mousedown先于onBlur执行

                      setTimeout(function () {
                        _this2.dataset.forEach(function (sp) {
                          sp.active = false;
                        });
                      });
                      var newShape = {
                        type: 'rect',
                        coor: [curPoint, curPoint],
                        active: true,
                        creating: true
                      };

                      if (!!_this2.createLabelFillStyle) {
                        newShape.labelFillStyle = _this2.createLabelFillStyle;
                      }

                      if (!!_this2.createRectStrokeStyle) {
                        newShape.rectStrokeStyle = _this2.createRectStrokeStyle;
                      }

                      _this2.currentShape = newShape;
                    }
                  }

                  ;
                });
                this.canvas.addEventListener('mousemove', function (e) {
                  if (_this2.readonly) return;

                  if (e.buttons === 1 && _this2.spaceKeyDown) {
                    // 拖动背景
                    _this2.originPoint = [Math.round(e.offsetX - _this2.lastOriginPoint[0]), Math.round(e.offsetY - _this2.lastOriginPoint[1])];

                    _this2.update();
                  } else if (e.buttons === 1 && _this2.currentShape) {
                    var _this2$currentShape;

                    if (((_this2$currentShape = _this2.currentShape) === null || _this2$currentShape === void 0 ? void 0 : _this2$currentShape.type) === 'rect' && _this2.isInBackground(e)) {
                      var _this2$currentShape2;

                      // -- 画矩形 --
                      var offsetX = Math.round(e.offsetX / _this2.scale);
                      var offsetY = Math.round(e.offsetY / _this2.scale);
                      var x = Math.round(offsetX - _this2.originPoint[0] / _this2.scale);
                      var y = Math.round(offsetY - _this2.originPoint[1] / _this2.scale);
                      (_this2$currentShape2 = _this2.currentShape) === null || _this2$currentShape2 === void 0 ? void 0 : _this2$currentShape2.coor.splice(1, 1, [x, y]);

                      _this2.emit('updated', _this2.currentShape);

                      _this2.update();
                    }
                  }
                });
                this.canvas.addEventListener('mouseup', function (e) {
                  if (_this2.readonly) return;

                  if (_this2.currentShape && _this2.currentShape.creating) {
                    var moveX = Math.abs(Math.round(e.offsetX / _this2.scale) - _this2.movePoint[0]);
                    var moveY = Math.abs(Math.round(e.offsetY / _this2.scale) - _this2.movePoint[1]);
                    var coor = _this2.currentShape.coor;

                    var _coor = _slicedToArray(coor, 2),
                        _coor$ = _slicedToArray(_coor[0], 2),
                        x0 = _coor$[0],
                        y0 = _coor$[1],
                        _coor$2 = _slicedToArray(_coor[1], 2),
                        x1 = _coor$2[0],
                        y1 = _coor$2[1];

                    if (Math.abs(x0 - x1) < _this2.rectMinWidth || Math.abs(y0 - y1) < _this2.rectMinHeight) {
                      _this2.emit('error', "\u5BBD\u4E0D\u80FD\u5C0F\u4E8E".concat(_this2.rectMinWidth, ",\u9AD8\u4E0D\u80FD\u5C0F\u4E8E").concat(_this2.rectMinHeight));
                    } else if ([moveX, moveY].every(function (dis) {
                      return dis < _this2.minDrawSize;
                    })) {
                      // 发生点击
                      _this2.emit('error', '发生点击');
                    } else {
                      _this2.currentShape.coor = [[Math.min(x0, x1), Math.min(y0, y1)], [Math.max(x0, x1), Math.max(y0, y1)]];

                      _this2.dataset.push(_this2.currentShape);

                      _this2.currentShape = undefined;

                      _this2.emit('add', e);
                    }
                  }
                });

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _init.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: "update",
    value: function update() {
      var _this3 = this;

      this.ctx.save();
      this.ctx.clearRect(0, 0, this.canvas.clientWidth, this.canvas.clientHeight);
      this.ctx.translate(this.originPoint[0], this.originPoint[1]);
      this.paintImage();

      var datasets = _toConsumableArray(this.dataset);

      if (this.currentShape) {
        datasets.push(this.currentShape);
      }

      datasets.forEach(function (item) {
        switch (item.type) {
          case 'rect':
            _this3.drawRect(item);

            break;

          default:
            break;
        }
      });
      this.ctx.restore(); // console.log(this.dataset);
    } // 加载图片

  }, {
    key: "loadImage",
    value: function loadImage() {
      var _this4 = this;

      return new Promise(function (resolve) {
        if (_this4.imageLoaded) {
          resolve(true);
        } else {
          _this4.image.addEventListener('load', function () {
            _this4.emit('load');

            _this4.imageWidth = _this4.image.width;
            _this4.imageHeight = _this4.image.height;

            _this4.fitZoom();

            resolve(true);
          });
        }
      });
    } // 绘制图片

  }, {
    key: "paintImage",
    value: function paintImage() {
      this.ctx.drawImage(this.image, 0, 0, this.imageWidth, this.imageHeight);
    } // 设置图片路径

  }, {
    key: "setImage",
    value: function setImage(url) {
      this.imageLoaded = false;
      this.image.src = url;
      this.imageCrossOrigin && this.image.setAttribute('crossOrigin', this.imageCrossOrigin);
    } // 缩放图片

  }, {
    key: "setScale",
    value: function setScale(type) {
      if (!type && this.imageWidth <= 20 || type && this.imageWidth >= this.canvas.clientWidth * 100) return;

      if (type) {
        this.scaleStep++;
      } else {
        this.scaleStep--;
      }

      var abs = Math.abs(this.scaleStep);
      var width = this.imageWidth;
      this.imageWidth = Math.round(this.image.width * Math.pow(this.scaleStep >= 0 ? 1.05 : 0.95, abs));
      this.imageHeight = Math.round(this.image.height * Math.pow(this.scaleStep >= 0 ? 1.05 : 0.95, abs));
      this.stayPosition(this.imageWidth / width);
      this.update();
    }
    /**
     * 计算缩放步长
     * @param reset 是否重置
     */

  }, {
    key: "calcStep",
    value: function calcStep(reset) {
      if (reset) {
        this.scaleStep = 100;
        this.setScale(false);
      }

      if (this.imageWidth > this.canvas.clientWidth || this.imageHeight > this.canvas.clientHeight) {
        this.setScale(false);
        this.calcStep();
      }
    }
    /**
     * 适配背景图
     */

  }, {
    key: "fitZoom",
    value: function fitZoom() {
      this.calcStep(true); // if (this.imageHeight / this.imageWidth >= this.canvas.clientHeight / this.canvas.clientWidth) {
      //   this.imageWidth = this.image.width / (this.image.height / this.canvas.clientHeight);
      //   this.imageHeight = this.canvas.clientHeight;
      // } else {
      //   this.imageWidth = this.canvas.clientWidth;
      //   this.imageHeight = this.image.height / (this.image.width / this.canvas.clientWidth);
      // }
      // this.originPoint = [
      //   (this.canvas.clientWidth - this.imageWidth) / 2,
      //   (this.canvas.clientHeight - this.imageHeight) / 2,
      // ];

      this.imageWidth = this.canvas.clientWidth;
      this.imageHeight = this.image.height / (this.image.width / this.canvas.clientWidth);
      this.originPoint = [(this.canvas.clientWidth - this.imageWidth) / 2, 0];
      this.update();
    }
    /**
     * 保持缩放中心
     * @param scale nummer
     */

  }, {
    key: "stayPosition",
    value: function stayPosition(scale) {
      this.originPoint = [this.canvas.clientWidth / 2 - (this.canvas.clientWidth / 2 - this.originPoint[0]) * scale, this.canvas.clientHeight / 2 - (this.canvas.clientHeight / 2 - this.originPoint[1]) * scale];
    }
    /**
       * 判断鼠标是否在背景图内部
       * @param e MouseEvent
       * @returns 布尔值
       */

  }, {
    key: "isInBackground",
    value: function isInBackground(e) {
      var offsetX = e.offsetX / this.scale;
      var offsetY = e.offsetY / this.scale;
      return offsetX >= this.originPoint[0] / this.scale && offsetY >= this.originPoint[1] / this.scale && offsetX <= this.originPoint[0] / this.scale + this.image.width && offsetY <= this.originPoint[1] / this.scale + this.image.height;
    }
    /**
     * 绘制label
     * @param point 位置
     * @param label 文本
     */

  }, {
    key: "drawLabel",
    value: function drawLabel(point, shape) {
      var _this5 = this;

      var labelFillStyle = shape.labelFillStyle,
          labelBackgroundColor = shape.labelBackgroundColor,
          _shape$label = shape.label,
          label = _shape$label === void 0 ? '' : _shape$label,
          _shape$coor = _slicedToArray(shape.coor, 2),
          _shape$coor$ = _slicedToArray(_shape$coor[0], 2),
          x0 = _shape$coor$[0],
          y0 = _shape$coor$[1],
          _shape$coor$2 = _slicedToArray(_shape$coor[1], 2),
          x1 = _shape$coor$2[0],
          y1 = _shape$coor$2[1];

      if (label.length > 0) {
        var newStr = label;
        var textWidth = Math.max(Math.abs(x0 - x1) * this.scale, this.labelMinWidth);

        var _point$map = point.map(function (a) {
          return a * _this5.scale;
        }),
            _point$map2 = _slicedToArray(_point$map, 2),
            x = _point$map2[0],
            y = _point$map2[1];

        var toleft = this.image.width - point[0] < (textWidth + 4) / this.scale;
        var toTop = this.image.height - point[1] < 16 / this.scale;
        this.ctx.save(); // this.ctx.fillRect(toleft ? (x - textWidth - 3) : (x + 1), toTop ? (y - 15) : y + 1, textWidth + 4, 16);

        this.ctx.font = this.labelFont; // 绘制多行文本

        var drawTexts = []; //label的宽度可能会稍微比设定的textWidth宽一点点

        var labelMaxWidth = 0; // 1.先通过换行符分割

        newStr.split('\n').forEach(function (lineText) {
          // 每次开始截取的字符串的索引
          var lastSubStrIndex = 0;

          if (textWidth >= _this5.ctx.measureText(lineText).width) {
            // 单行文本
            labelMaxWidth = Math.max(_this5.ctx.measureText(lineText).width, labelMaxWidth);
            drawTexts.push(lineText);
          } else {
            // 文字超出
            for (var i = 1; i <= lineText.length; i++) {
              // substring 第二个参数比要提取的子串的最后一个字符在 string Object中的位置多1，所以要取到最后个字需要到字符串的length
              var str = lineText.substring(lastSubStrIndex, i);

              if (_this5.ctx.measureText(str).width >= textWidth) {
                labelMaxWidth = Math.max(_this5.ctx.measureText(str).width, labelMaxWidth);
                drawTexts.push(str);
                lastSubStrIndex = i;
              } else if (i === lineText.length) {
                drawTexts.push(str);
              }
            }
          }
        });
        var posY = toTop ? y - (y1 - y0) * this.scale - this.labelLineHeight * drawTexts.length + 14 : y + 14;
        var posX = toleft ? this.image.width * this.scale - textWidth - 20 : x + 2; // 绘制文字底色

        this.ctx.fillStyle = labelBackgroundColor || this.labelBackgroundColor; // +5 让背景不顶边

        this.ctx.fillRect(posX, posY - this.labelLineHeight + 5, labelMaxWidth + 5, this.labelLineHeight * drawTexts.length); // 设置字体颜色

        this.ctx.fillStyle = labelFillStyle || this.labelFillStyle;
        drawTexts.forEach(function (text, i) {
          // 描边+阴影方式 加底色
          // this.ctx.shadowColor="black";
          // this.ctx.shadowBlur=2;
          // this.ctx.lineWidth=6;
          // this.ctx.strokeStyle="white";
          // this.ctx.strokeText(text, posX, posY + this.labelLineHeight * i);
          // this.ctx.shadowBlur=0;
          // this.ctx.fillStyle="red";
          // this.ctx.fillText(text, posX, posY + this.labelLineHeight * i);
          _this5.ctx.fillText(text, posX, posY + _this5.labelLineHeight * i);
        });
        this.ctx.fill(); // this.ctx.stroke();

        this.ctx.restore();
      }
    }
  }, {
    key: "drawRect",
    value: function drawRect(shape) {
      var _this6 = this;

      var rectStrokeStyle = shape.rectStrokeStyle,
          coor = shape.coor;

      var _coor$map = coor.map(function (a) {
        return a.map(function (b) {
          return Math.round(b * _this6.scale);
        });
      }),
          _coor$map2 = _slicedToArray(_coor$map, 2),
          _coor$map2$ = _slicedToArray(_coor$map2[0], 2),
          x0 = _coor$map2$[0],
          y0 = _coor$map2$[1],
          _coor$map2$2 = _slicedToArray(_coor$map2[1], 2),
          x1 = _coor$map2$2[0],
          y1 = _coor$map2$2[1];

      this.ctx.save(); // this.ctx.fillStyle = fillStyle || FILL_STYLE;

      this.ctx.strokeStyle = rectStrokeStyle || this.rectStrokeStyle;
      var w = x1 - x0;
      var h = y1 - y0;
      this.drawLabel([coor[0][0], coor[1][1]], shape);
      this.ctx.strokeRect(x0, y0, w, h);
      this.ctx.restore();
    }
  }, {
    key: "setData",
    value: function setData(data) {
      this.dataset = data;
    }
  }, {
    key: "clean",
    value: function clean() {
      this.setData([]);
      this.update();
    }
  }, {
    key: "undo",
    value: function undo() {
      this.dataset.pop();
      this.update();
    }
    /**
     * 获取绘制的图片
     */

  }, {
    key: "getDrawImage",
    value: function getDrawImage() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'image/jpeg';
      var quality = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
      var imgData = this.canvas.toDataURL(type, quality);
      return imgData;
    }
    /**
     * 删除指定矩形
     * @param index number
     */

  }, {
    key: "deleteActiveShape",
    value: function deleteActiveShape() {
      var num = this.dataset.findIndex(function (x) {
        return x.active;
      });

      if (num > -1) {
        this.emit('delete', this.dataset[num]);
        this.dataset.splice(num, 1);
        this.update();
      }
    }
  }, {
    key: "create",
    value: function create(type) {
      this.createType = type;
    }
  }]);

  return CanvasComment;
}(EventBus);

export { CanvasComment as default };