"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var EventBus = /*#__PURE__*/function () {
  function EventBus() {
    (0, _classCallCheck2["default"])(this, EventBus);
    this._eventTree = {};
  }

  (0, _createClass2["default"])(EventBus, [{
    key: "on",
    value:
    /**
    * 注册事件
    * @param eventName 事件名称
    * @param cb 回调方法
    */
    function on(eventName, cb) {
      var fns = this._eventTree[eventName];

      if (Array.isArray(fns)) {
        fns.push(cb);
      } else {
        this._eventTree[eventName] = [cb];
      }
    }
    /**
     * 触发事件
     * @param eventName 事件名称
     * @param payload 传递参数
     */

  }, {
    key: "emit",
    value: function emit(eventName) {
      for (var _len = arguments.length, payload = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        payload[_key - 1] = arguments[_key];
      }

      var fns = this._eventTree[eventName];

      if (Array.isArray(fns)) {
        fns.forEach(function (fn) {
          return fn.apply(void 0, payload);
        });
      }
    }
    /**
     * 注销事件
     * @param eventName 事件名称
     * @param cb 传递参数
     */

  }, {
    key: "off",
    value: function off(eventName, cb) {
      var fns = this._eventTree[eventName];
      var index = fns.find(function (fn) {
        return fn === cb;
      });

      if (Array.isArray(fns) && index) {
        fns.splice(index, 1);
      }
    }
  }]);
  return EventBus;
}();

exports["default"] = EventBus;